// Programming 2D Games
// Copyright (c) 2011 by: 
// Charles Kelly
// ship.h v1.0

#ifndef _ENTITYMONSTER_H            // Prevent multiple definitions if this 
#define _ENTITYMONSTER_H            // file is included in more than one place
#define WIN32_LEAN_AND_MEAN

#include "entity.h"
#include "constants.h"
#include "EntityPlayer.h"
#include "infochat.h"


namespace EntityMonsterNS
{
    const int   WIDTH = 128;                // image width (each frame)
    const int   HEIGHT = 128;               // image height
    const int   X = GAME_WIDTH/2 - TEXTURE_SIZE; // location on screen
    const int   Y = GAME_HEIGHT/2 - TEXTURE_SIZE;
	
}

// inherits from Entity class
class EntityMonster : public Entity
{
private:
    float   oldX, oldY, oldAngle;
    float   rotation;                       // current rotation rate (radians/second)
	LARGE_INTEGER lastAttack;
	LARGE_INTEGER tmrFreq;
	

public:
    // constructor
    EntityMonster();

    // inherited member functions
    virtual bool initialize(Game *gamePtr, int width, int height, int ncols,
                            TextureManager *textureM);
    void update(float frameTime);
	void attackPlayer(EntityPlayer& thePlayer, int level);
	void repair();
	bool EntityMonster::isMoving();

    // new functions
    void setVelocityX(float v)  {velocity.x = v;}
	int getMonsterX();
	int getMonsterY();
	int getMaxHealth(int level) { return 100 + (level * 30); }
	int getDroppedExp(int level) { return 10 + (level * 10); }
	void setName(std::string name) { mobName = name; }
	std::string getName() { return mobName; }

	int		movement;
	int		xMoving;
	int		yMoving;
	int		xOffset;
	int		yOffset;
	byte	standingFrame;
	std::string mobName;
	

	
};
#endif

