#include "ItemManager.h"


ItemManager::ItemManager() {
	int i=0;
	for (; i < .01 * RND_MAX_ITEMS; i++) {
		itemPool[i] = SWORD.itemID;
	}
	int a = i;
	for (; i < a + .01 * RND_MAX_ITEMS; i++) {
		itemPool[i] = SHIELD.itemID;
	}
	a = i;
	for (; i < a + (.2+.07) * RND_MAX_ITEMS; i++) {
		itemPool[i] = FOOD.itemID;
	}
	a = i;
	for (; i < a + (.1+.1) * RND_MAX_ITEMS; i++) {
		itemPool[i] = SMALL_POTION.itemID;
	}
	a = i;
	for (; i < a + .05 * RND_MAX_ITEMS; i++) {
		itemPool[i] = MEDIUM_POTION.itemID;
	}
	a = i;
	for (; i < a + .025 * RND_MAX_ITEMS; i++) {
		itemPool[i] = LARGE_POTION.itemID;
	}
	a = i;
	for (; i < a + .012 * RND_MAX_ITEMS; i++) {
		itemPool[i] = GIGANTIC_POTION.itemID;
	}
	a = i;
	for (; i < a + .013 * RND_MAX_ITEMS; i++) {
		itemPool[i] = STAIRS_TELEPORT_SCROLL.itemID;
	}
	a = i;
	for (; i < a + .05 * RND_MAX_ITEMS; i++) {
		itemPool[i] = TELEPORT_SCROLL.itemID;
	}
	a = i;
	for (; i < a + (.2+.07) * RND_MAX_ITEMS; i++) {
		itemPool[i] = MONEY_BAG.itemID;
	}
	a = i;
	for (; i < a + .005 * RND_MAX_ITEMS; i++) {
		itemPool[i] = HEALING_RING.itemID;
	}
	a = i;
	for (; i < a + .005 * RND_MAX_ITEMS; i++) {
		itemPool[i] = SPEED_RING.itemID;
	}
	a = i;
	for (; i < a + .005 * RND_MAX_ITEMS; i++) {
		itemPool[i] = DEATH_RING.itemID;
	}
	a = i;
	for (; i < a + .005 * RND_MAX_ITEMS; i++) {
		itemPool[i] = EXP_RING.itemID;
	}
	a = i;
	for (; i < a + .005 * RND_MAX_ITEMS; i++) {
		itemPool[i] = STR_BOOK.itemID;
	}
	a = i;
	for (; i < a + .005 * RND_MAX_ITEMS; i++) {
		itemPool[i] = DEF_BOOK.itemID;
	}
	a = i;
	for (; i < a + .005 * RND_MAX_ITEMS; i++) {
		itemPool[i] = PICKAXE.itemID;
	}
	a = i;
	for (; i < a + .055 * RND_MAX_ITEMS; i++) {
		itemPool[i] = MAP_BOOK.itemID;
	}
}

void ItemManager::handleItemUse(EntityPlayer& thePlayer, levelManager& theLevel, ItemInfo& theItem)
{
	int temp = 0; //used in a lot of the calculations
	if (theItem.itemID == -1) {
		return; //Null item;
	} else if (theItem.itemID == MONEY_BAG.itemID) {
		temp = rand() % 11;
		thePlayer.setMoney(thePlayer.getMoney() + temp);
		thePlayer.getAudio()->playCue(collectMoney);
		infochat::addChat("You found " + std::to_string(temp) + " gold!");
	}  else if (theItem.itemID == FOOD.itemID) {
		thePlayer.setHealth(thePlayer.getHealth() + 10);
		thePlayer.getAudio()->playCue(eatFood);
		if (thePlayer.getHealth() > thePlayer.getMaxHealth()) {
			temp = 10 - (thePlayer.getHealth() - thePlayer.getMaxHealth());
			if (temp > 0)
				infochat::addChat("You found some food and regained " + std::to_string(temp) + " health!");
			thePlayer.setHealth(thePlayer.getMaxHealth());
		} else {
			infochat::addChat("You found some food and regained 10 health!");
		}
	} else {
		for (int i=0; i<PLAYER_MAX_ITEMS; i++) {
			if (thePlayer.Items[i].itemID == -1) {
				thePlayer.Items[i] = theItem;
				infochat::addChat("You found a " + theItem.ItemName + "!");
				theLevel.clearItem(theItem.xCoord, theItem.yCoord);
				thePlayer.getAudio()->playCue(itemPickup);
				return;
			}
		}
		return; //No space for item, break otherwise we will delete it anyway.
	}
	theLevel.clearItem(theItem.xCoord, theItem.yCoord);
	//DEATH_RING,
}
void ItemManager::handleItemClick(EntityPlayer& thePlayer, levelManager& theLevel, ItemInfo& theItem, int index)
{
	int temp;
	if (SMALL_POTION.itemID == theItem.itemID || MEDIUM_POTION.itemID == theItem.itemID || LARGE_POTION.itemID == theItem.itemID || GIGANTIC_POTION.itemID == theItem.itemID) {
		if (thePlayer.getMaxHealth() == thePlayer.getHealth()) {
			infochat::addChat("There is no sense in drinking this now.");
			return;
		}
		thePlayer.getAudio()->playCue(potionUse);
		float healAmount = MEDIUM_POTION.itemID == theItem.itemID ? .25 : LARGE_POTION.itemID == theItem.itemID ? .5 : GIGANTIC_POTION.itemID == theItem.itemID ? 1 : .1;
		thePlayer.setHealth(thePlayer.getHealth() + (thePlayer.getMaxHealth() * healAmount));
		if (thePlayer.getHealth() > thePlayer.getMaxHealth()) {
			temp = (thePlayer.getMaxHealth() * healAmount) - (thePlayer.getHealth() - thePlayer.getMaxHealth());
			if (temp > 0)
				infochat::addChat("You drank the potion and regained " + std::to_string(temp) + " health!");
			thePlayer.setHealth(thePlayer.getMaxHealth());
		} else {
			infochat::addChat("You drank the potion and regained " + std::to_string((int)(thePlayer.getMaxHealth() * healAmount)) + " health!");
		}	
	}else if (theItem.itemID == MAP_BOOK.itemID) {
		thePlayer.getAudio()->playCue(mapReveal);
		for (int x=0; x<LEVEL_WIDTH; x++) {
			for (int y=0; y<LEVEL_HEIGHT; y++) {
				theLevel.setFogTileAt(x,y,-1);
			}
		}
		infochat::addChat("You read the map and the fog disappears...");
	} else if (theItem.itemID == TELEPORT_SCROLL.itemID) {
		Coords newPlace = theLevel.getSpawnableCoords();
		if (newPlace.xCoord != 0 || newPlace.yCoord != 0) {
			thePlayer.setPlayerX(newPlace.xCoord);
			thePlayer.setPlayerY(newPlace.yCoord);
			thePlayer.getAudio()->playCue(teleport);
			infochat::addChat("You read the cryptic text out loud and black out...");
			infochat::addChat("	You seem to have awoken somewhere else...");
			theLevel.clearFog();
		} else {
			infochat::addChat("You read the cryptic text out loud and black out...");
			infochat::addChat("	You are right where you were before... You must have read it incorrectly!");
		}
	} else if (theItem.itemID == STAIRS_TELEPORT_SCROLL.itemID) {
		Coords newPlace = theLevel.getSpawnableCoords();
		thePlayer.setPlayerX(theLevel.stairs.xCoord+1);
		thePlayer.setPlayerY(theLevel.stairs.yCoord+1);
		thePlayer.getAudio()->playCue(teleport);
		infochat::addChat("You read the cryptic text out loud and black out...");
		infochat::addChat("	You seem to have awoken somewhere else...");
		theLevel.clearFog();
	} else if (theItem.itemID == PICKAXE.itemID) {
		int xCoord = thePlayer.getPlayerX();
		int yCoord = thePlayer.getPlayerY();
		if (thePlayer.getLastDir() == DIR_UP) {
			yCoord--;
		} else if (thePlayer.getLastDir() == DIR_DOWN) {
			yCoord++;
		} else if (thePlayer.getLastDir() == DIR_LEFT) {
			xCoord--;
		} else if (thePlayer.getLastDir() == DIR_RIGHT) {
			xCoord++;
		}

		if (theLevel.getTileAt(4, xCoord, yCoord) == doubleWallVertical && theLevel.getTileAt(4, xCoord, yCoord-1) == doubleWallVertical && theLevel.getTileAt(4, xCoord, yCoord+1) == doubleWallVertical) {
			theLevel.setTileAt(0,xCoord,yCoord, theLevel.getRandomFloorTile());
			theLevel.setTileAt(4,xCoord,yCoord, -1);
			theLevel.setTileAt(4, xCoord, yCoord-1, verticalDoorTop);
			theLevel.setTileAt(4, xCoord, yCoord+1, verticalDoorBottom);
			infochat::addChat("You have opened a path in the wall! Your pickaxe seems to have broken though.");
		} else if (theLevel.getTileAt(4, xCoord, yCoord) == doubleWallHorizontal && theLevel.getTileAt(4, xCoord-1, yCoord) == doubleWallHorizontal && theLevel.getTileAt(4, xCoord+1, yCoord) == doubleWallHorizontal) {
			theLevel.setTileAt(0,xCoord,yCoord, theLevel.getRandomFloorTile());
			theLevel.setTileAt(4,xCoord,yCoord, -1);
			theLevel.setTileAt(4, xCoord+1, yCoord, horizontalDoorRight);
			theLevel.setTileAt(4, xCoord-1, yCoord, horizontalDoorLeft);
			infochat::addChat("You have opened a path in the wall! Your pickaxe seems to have broken though.");
		} else {
			infochat::addChat("This wall seems to be too stable to break through!");
			return;
		}
		thePlayer.getAudio()->playCue(pixkaxe);
	} else if (theItem.type == WEAPON) {
		ItemInfo temp = thePlayer.Sword;
		thePlayer.Sword = thePlayer.Items[index];
		thePlayer.Items[index] = temp;
		thePlayer.getAudio()->playCue(itemPickup);
		return;
	} else if (theItem.type == ARMOR) {
		ItemInfo temp = thePlayer.Armor;
		thePlayer.Armor = thePlayer.Items[index];
		thePlayer.Items[index] = temp;
		thePlayer.getAudio()->playCue(itemPickup);
		return;
	} else if (theItem.type == RING) {
		ItemInfo temp = thePlayer.Ring;
		thePlayer.Ring = thePlayer.Items[index];
		thePlayer.Items[index] = temp;
		thePlayer.getAudio()->playCue(itemPickup);
		return;
	} else if (theItem.itemID == STR_BOOK.itemID) {
		thePlayer.getAudio()->playCue(bookUse);
		temp = rand() % 11;
		thePlayer.setStrStat(thePlayer.getStrStat() + temp);
		infochat::addChat("After straining to lift the book over and over you gained " + std::to_string(temp) + " strength!");
	} else if (theItem.itemID == DEF_BOOK.itemID) {
		thePlayer.getAudio()->playCue(bookUse);
		temp = rand() % 11;
		thePlayer.setDefStat(thePlayer.getDefStat() + temp);
		infochat::addChat("After using the pages to line your armor you gained " + std::to_string(temp) + " defence!");
	} 
	thePlayer.Items[index] = ItemInfo();
}
int ItemManager::getItemStrength(Item& theItem)
{
	return 0;
}
int ItemManager::getItemDefence(Item& theItem) 
{
	return 0;
}
void ItemManager::tickItem(Item& theItem) 
{

}// Called on rings to use their effects.