// Programming 2D Games
// Copyright (c) 2011 by: 
// Charles Kelly
// createThisClass.h

#ifndef _CREATETHIS_H           // Prevent multiple definitions if this 
#define _CREATETHIS_H           // file is included in more than one place
#define WIN32_LEAN_AND_MEAN

#include <string>
#include <sstream>
#include <math.h> 
#include "game.h"
#include "textureManager.h"
#include "image.h"
#include "textDX.h"
#include "EntityPlayer.h"
#include "floorGenerator.h"
#include "levelManager.h"
#include "ItemManager.h"
#include "infochat.h"
#include "HUD.h"
//=============================================================================
// This class is the core of the game
//=============================================================================
class CreateThis : public Game
{
private:
    // game items
    TextureManager spriteSheet; // textures
    Image   tile;               
    TextDX  *dxFont;            // DirectX font
	floorGen floorGenerator;

	ItemManager itemManager;

	//Player
	EntityPlayer thePlayer;
	TextureManager playerSprites;
	levelManager *theLevel;
	HUD myHud;
	bool needToClearFog;
	
	bool noClip;
	bool stopMobs;

public:
    // Constructor
    CreateThis();
    // Destructor
    virtual ~CreateThis();
    // Initialize the game
    void initialize(HWND hwnd);
    void update();      // must override pure virtual from Game
    void ai();          // "
    void collisions();  // "
    void render();      // "
    void releaseAll();
    void resetAll();
	void drawNumber(int x, int y, int number);
	void drawNumber(int x, int y, int number, int number2);
	void consoleCommand();
};

#endif
