#ifndef _FLOORGEN_H           // Prevent multiple definitions if this 
#define _FLOORGEN_H           // file is included in more than one place
#define WIN32_LEAN_AND_MEAN

#include <string>
#include <sstream>
#include <time.h>
#include "constants.h"
#include "levelManager.h"
#include "ItemManager.h"


//=============================================================================
// This generates new dungeon floors with random size rooms and hallways.
//=============================================================================
class floorGen
{
private:
	
	

public:
    // Constructor
    floorGen();
    // Destructor
    virtual ~floorGen();

	bool isTileReplaceable(int tileIndex, levelManager& theLevel);
	void insertRoom(int xCoord, int yCoord, int width, int height, levelManager& theLevel);
	bool doesRoomFit(int xCoord, int yCoord, int width, int height, levelManager& theLevel);
	bool generateRoom(int anX, int anY, int roomWidth, int roomHeight, levelManager& theLevel, int recursLevel);
	void generateStairs(levelManager& theLevel, bool up);
	void generateItems(levelManager& theLevel, ItemManager& itemManager, EntityPlayer& thePlayer);
	void spawnPlayerCoords(levelManager& theLevel, int playerLastDirection, bool goingUp);
	void generateNewFloor(levelManager& theLevel, int playerLastDirection, bool goingUp);
};

#endif